%define anolis_release 3

%bcond_with bootstrap

Name:		libffi
Version:	3.4.4
Release:	%{anolis_release}%{?dist}
Summary:	A portable foreign function interface library
License:	MIT
URL:		http://sourceware.org/libffi

Source0:	https://github.com/libffi/libffi/releases/download/v%{version}/%{name}-%{version}.tar.gz

Patch1001:	libffi-Add-sw64-architecture.patch

BuildRequires: make
BuildRequires: gcc
%if %{without bootstrap}
BuildRequires: gcc-c++
BuildRequires: dejagnu
%endif

%description
Compilers for high level languages generate code that follow certain
conventions.  These conventions are necessary, in part, for separate
compilation to work.  One such convention is the "calling convention".
The calling convention is a set of assumptions made by the compiler
about where function arguments will be found on entry to a function.  A
calling convention also specifies where the return value for a function
is found.  

Some programs may not know at the time of compilation what arguments
are to be passed to a function.  For instance, an interpreter may be
told at run-time about the number and types of arguments used to call a
given function.  `Libffi' can be used in such programs to provide a
bridge from the interpreter program to compiled code.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%package	devel
Summary:	Development files for %{name}
Requires:	%{name} = %{version}-%{release}

%description	devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%prep
%setup -q
%patch1001 -p1

%build
# For now we disable the static templates to avoid ghc and
# gobject-introspection failures:
# https://gitlab.haskell.org/ghc/ghc/-/issues/20051
# https://gitlab.gnome.org/GNOME/gobject-introspection/-/merge_requests/283
%configure \
   %ifarch riscv64
   --libdir=%{_libdir} \
   %endif
   --disable-static \
   --disable-exec-static-tramp
%make_build

%check
%if %{without bootstrap}
%make_build check
%endif

%install
%make_install

%ifarch riscv64
mv -v ${RPM_BUILD_ROOT}%{_libdir}/lp64d/* ${RPM_BUILD_ROOT}%{_libdir}/
rm -rf ${RPM_BUILD_ROOT}%{_libdir}/lp64d
%endif

%files
%license LICENSE
%{_libdir}/libffi.so.8
%{_libdir}/libffi.so.8.*

%files doc
%doc README.md

%files devel
%{_libdir}/pkgconfig/*.pc
%{_includedir}/ffi*.h
%{_libdir}/*.so
%{_mandir}/man3/*
%{_infodir}/libffi.info.*

%changelog
* Sat Apr 26 2025 Shangtong Guo <guo.shangtong@zte.com.cn> - 3.4.4-3
- add support for riscv64 build

* Wed Mar 12 2025 Chunchao Zhang <chunchao@nfschina.com> - 3.4.4-2
- add sw_64 support

* Sat Dec 31 2022 Funda Wang <fundawang@yeah.net> - 3.4.4-1
- New version 3.4.4

* Sun Oct 09 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 3.4.2-2
- add doc package

* Tue Mar 08 2022 liuzhilin <liuzhilin@uniontech.com> - 3.4.2-1
- Init for Anolis OS
